﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Zadatak03
{
    internal class Program
    {
        static void Main(string[] args)
        {
            ClientHost host = new ClientHost();
            ClientHostImproved hostImproved = new ClientHostImproved();

            // Subscribing
            host.OnClientArrived += CallTeam;
            host.OnClientArrived += CallSupervisor;
            hostImproved.OnClientArrived += CallTeamImproved;
            hostImproved.OnClientArrived += CallSupervisorImproved;
            // Subscribing with Lambda
            host.OnClientArrived += (client) =>
            {
                Console.WriteLine($"Arrange a meeting with {client}");
            };
            hostImproved.OnClientArrived += (sender, eventArgs) =>
            {
                Console.WriteLine($"Arrange a meeting with {eventArgs.Client}");
            };

            // Unsubscribing
            host.OnClientArrived -= CallTeam;
            hostImproved.OnClientArrived -= CallTeamImproved;

            // Publishing
            host.ClientHasArrived(new Client
            {
                FirstName = "Pero",
                LastName = "Peric"
            });
            hostImproved.ClientHasArrived(new Client
            {
                FirstName = "Ana",
                LastName = "Anic"
            });
        }

        private static void CallSupervisorImproved(object sender, ClientEventArgs args)
        {
            Console.WriteLine($"Dear Supervisor, {args.Client} has arrived");
        }

        private static void CallTeamImproved(object sender, ClientEventArgs args)
        {
            Console.WriteLine($"Hello Team, {args.Client} has arrived");
        }

        private static void CallSupervisor(Client client)
        {
            Console.WriteLine($"Dear Supervisor, {client} has arrived");
        }

        private static void CallTeam(Client client)
        {
            Console.WriteLine($"Hello Team, {client} has arrived");
        }
    }
}
